package mutations

import (
	"git.lehouerou.net/laurent/sorare/graphql"
	"git.lehouerou.net/laurent/sorare/types"
)

type prepareOfferInput struct {
	ClientMutationId     string                    `json:"clientMutationId"`
	ReceiveAmount        *AmountInput              `json:"receiveAmount"`
	ReceiveAssetIds      []string                  `json:"receiveAssetIds"`
	ReceiverSlug         string                    `json:"receiverSlug"`
	SendAmount           *AmountInput              `json:"sendAmount"`
	SendAssetIds         []string                  `json:"sendAssetIds"`
	SettlementCurrencies []types.SupportedCurrency `json:"settlementCurrencies"`
	Type                 types.OfferType           `json:"type"`
}

type PrepareOfferParams struct {
	Input prepareOfferInput `graphql:"input"`
}

func (m *Mutations) newPrepareOfferMutation() *graphql.Mutation[AuthorizationPayload, PrepareOfferParams] {
	return graphql.NewMutation[AuthorizationPayload, PrepareOfferParams](m.c, "prepareOffer")
}
